/* $VER: DMArcList2Win2.rexx 1.3 (30.11.05) by J. Tierney

  DiskMasterII Archive List To Window  v1.1
  03/28/98	J. Tierney <jtierney@cyberlink-inc.com>
  10/11/05	Javier de las Rivas <javierdlr@jazzfree.com>
			-Uses xadUnFile to list the archive, so it supports all
			 archives xadmaster.library is able to read.
			V1.2 (13.11.05)
			-Archive list is Source locked.
			-Runs on DM.#? port.
			V1.3 (30.11.05)
			-The '-' from top lines fills the lister's total width.
			-Thousands separator (variable usedots).


  Purpose:  Opens a new file-display window, listing an archive's contents.

  DM Usage:  Rexx DMArcList2Win2.rexx <mode> <filename>

	     <mode> - 0 - List in current (Source) window.
		      	  1 - List in Dest window.
		      	  2 - New window.
	 <filename> - Archive (lzx|lha|zip|...) to list.

  Notes:
    - List format:	<archive path/name>
					<file path/name> <file size>

    - Entries with a size of 0 (eg. dirs) are skipped.
*/

/* Dimensions for the new window. */
/* Change these to suit yourself. */
winx = 20	/* X      */
winy = 50 	/* Y      */
winw = 267	/* Width  */
winh = 327	/* Height */
/* Thousands separator. enabled->1; disabled->0 */
usedots = 1

/* Strings to translate: reqtxt, reqOK & line1 */
reqtxt = '"Selected file is not an archive."'
reqOK  = '"OK"'
    /* First line on the window of listed archive */
line1  = '------- Contents of archive -------'


OPTIONS RESULTS

PARSE ARG mode arc

'DESELECT *'

arc = STRIP(arc, 'L')
who = ADDRESS()
tmpfile = 'T:ArcList.' || who

ADDRESS COMMAND 'C:xadUnFile >' || tmpfile 'INFO NOCOMMENT' arc

fh = OPEN('fh', tmpfile, 'R')
line = READLN('fh')
IF POS('An error occured', line) = 1 THEN DO
  ADDRESS COMMAND 'C:RequestChoice "'who': DMArcList2Win2.rexx" 'reqtxt' 'reqOK''
  CALL CLOSE('fh')
  ADDRESS COMMAND 'C:Delete >NIL:' tmpfile 'QUIET'
  EXIT 0
END
line = READLN('fh')

i = 4
maxnamelen = 0
maxsizelen = 0
flist. = ''
DO FOREVER
  line = READLN('fh')
  IF EOF('fh') THEN LEAVE
  PARSE VAR line sz . . . . nm
  IF (sz > 0) & (nm ~= '') THEN DO
    nm = STRIP(nm, 'B')
    maxnamelen = MAX(maxnamelen, LENGTH(nm))
    maxsizelen = MAX(maxsizelen, LENGTH(sz))
    flist.i.name = nm
	/* start of thousands separator */
	setdot = LENGTH(sz)
	DO WHILE setdot > 3 & usedots = 1
		setdot = setdot - 3
		sz = INSERT('.', sz, setdot)
	END
	/* end of thousands separator */
    flist.i.size = sz
    i = i + 1
  END
END
/* Add thousands separator chars to maxsizelen if usedots=1 */
maxsizelen = maxsizelen + TRUNC( (maxsizelen-1)/3, 0 ) * usedots

CALL CLOSE('fh')
ADDRESS COMMAND 'C:Delete >NIL:' tmpfile
flist.count = i - 1

/* I know i could put it on one only codeline, but... :-P */
/*totlen = MAX( LENGTH(line1), MAX( maxnamelen+maxsizelen+1, LENGTH(arc) ) )*/
deflen = LENGTH(line1)
totlen = maxnamelen+maxsizelen+1
totlen = MAX(totlen, LENGTH(arc) )
totlen = MAX(deflen, totlen)

flist.1 = line1||COPIES('-', totlen-deflen)
flist.2 = arc
flist.3 = COPIES('-', totlen)
DO i = 4 TO flist.count
  flist.i = LEFT(flist.i.name, maxnamelen) RIGHT(flist.i.size, maxsizelen)
END

ADDRESS VALUE who
SELECT
  WHEN mode = 1 THEN 'WINDOW DEST'
  WHEN mode = 2 THEN 'OPENWINDOW LEFT='winx' TOP='winy' WIDTH='winw' HEIGHT='winh' ZOOMW='winw' PATH=T:'
  OTHERWISE NOP
END

'LOCK S'
'SETLIST 'flist
