/* $VER: DMArcSelExt2.rexx 1.3 (5.12.05) by J. Tierney

  DiskMasterII Archive Selective Extract  v1.3
  10/11/98  J. Tierney <jtierney@cyberlink-inc.com>
  10/11/05  Javier de las Rivas <javierdlr@jazzfree.com>
			-Changed to use with DMArcList2Win2.rexx +V1.1
			-Uses xadUnFile to list the archive, so it supports all
			 archives xadmaster.library is able to extract.
			-Extracting files with spaces now works.
  30/11/05	-Reread/activate destination lister to show extracted files.
  05/12/05  -If too many files to extract we must do it in small parts.


  Purpose:  Extracts selected files listed with DMArcList2Win2.rexx

  DM Usage:  Rexx DMArcSelExt2.rexx <dest>
*/

/* Strings to translate: reqtxt & line1 */
reqtxt = '"Source window is not an archive's list."'
    /* MUST BE 'line1' of DMArcList2Win2.rexx */
line1  = '------- Contents of archive -------'


OPTIONS RESULTS

PARSE ARG destdir

DIRLIST VAR flist COMMENT

IF POS(line1, flist.name.1) = 0 THEN DO
  'MSG' reqtxt
  EXIT 0
END

arc = flist.name.2

toext = ''
DO i = 4 TO flist.name.0
  IF flist.sel.i THEN DO
    fn = flist.name.i
    IF LEFT(flist.comment.i, 8) ~= 'FLIST.CO' THEN fn = fn || flist.comment.i
    x = LASTPOS(' ', fn)
    toext = toext '"'||STRIP(LEFT(fn, x - 1), 'T')||'"'
	IF LENGTH(toext) > 65300 THEN DO
  		CALL PRAGMA('D', destdir)
	  	ADDRESS COMMAND 'C:xadUnFile' arc '"" FILE' toext 'QUIET'
		toext = ''
	END
  END
END

toext = STRIP(toext, 'B')

IF toext ~= '' THEN DO
  CALL PRAGMA('D', destdir)
  ADDRESS COMMAND 'C:xadUnFile' arc '"" FILE' toext 'QUIET'
END

'DESELECT *'
'WINDOW Dest'
'NEWDIR %d'
