/* $VER: DM_CmtAll.rexx 1.4a (8.7.04) By J. Tierney

  DiskMaster II Comment All  v1.4a
  8/5/01, 7/4/04, 7/8/04  J. Tierney

  Function:  All selected files recieve the same comment.

  Usage:  DMCmtAll.rexx <default comment>

  Examples:  Rexx DMCmtAll.rexx
             Rexx DMCmtAll.rexx %c
             Rexx DMCmtAll.rexx "Hello World"

  Notes:
    - An empty string or "##" equals no comment.
    - Use \" to include double quotes (").  Ex: Bla \" bla
*/

OPTIONS RESULTS

PARSE ARG defcmt
IF LEFT(defcmt, 1) ~= '"' THEN defcmt = '"' || defcmt || '"'

'STATUS S'
IF result = 0 THEN EXIT 0

'CHOOSE TITLE="Comment All Files" TEXT="Enter comment:" BUTTONS=Okay|Cancel STRING=' || defcmt
IF btnvar = 0 THEN EXIT 1
comment = result
IF comment == '' THEN comment = '##'
ELSE comment = '"' || comment || '"'

DIRLIST VAR dlist SEL
dir = dlist.path
l = RIGHT(dir, 1)
IF (l ~= ':') & (l ~= '/') THEN dir = dir || '/'

DO i = 1 TO dlist.name.0
  'Comment' dir || dlist.name.i comment
END

'DESELECT *'
EXIT 0

