/* $VER: DMMultiExec.rexx 1.4 (23.2.03) by J. Tierney

  DiskMaster II Multi-Execute  v1.4
  2/23/97  J. Tierney

  Function:  Execute a command on selected files.

  Usage:  DMMultiExec.rexx <output (0|1)> <command>

  v1.4 (2/23/03)
    - Should work with filenames which contain spaces.

  v1.3 (10/2/98)
    - Changed to make use of new improved DirList.

  v1.2 (9/30/97)
    - Added 512 (apx) line length limit.

  v1.1 (9/16/97)
    - Added output option.

  v1.0 (9/14/97)
*/

OPTIONS RESULTS

PARSE ARG output cmd

cmd = STRIP(cmd, 'B')
IF output THEN DO
  port = ADDRESS()
  cmd = cmd '>"VNC:20/20/600/150/Output/CLOSE/AUTO/WAIT/SCREEN' port || '"'
  END
ELSE DO
  out = ''
END
cmdlen = LENGTH(cmd)

line. = ''
lc = 0
linelen = cmdlen
DIRLIST VAR dlist SEL
DO i = 1 TO dlist.name.0
  l = LENGTH(dlist.name.i)
  linelen = linelen + l + 1
  IF linelen > 510 THEN DO
    lc = lc + 1
    linelen = cmdlen
  END
  line.lc = line.lc '"' || dlist.name.i || '"'
END

IF line.0 ~= '' THEN DO
  STATUS P
  PRAGMA('D', result)
  DO i = 0 TO lc
    ADDRESS COMMAND cmd line.i
  END
  DESELECT '*'
END
