/* $VER:  DMPathHist.rexx 1.3 (19.2.03)

  DiskMaster II Path History  v1.3
  02/19/03  J. Tierney

  Purpose:  Opens a Cmd window with button-links to the last 15 visited
            directories.

  Usage:  Rexx DMPathHist.rexx

  Notes:
  - Edit the variables "windims" and "btncolr" (below) to suit yourself.
*/

windims = 'LEFT=251 TOP=7 WIDTH=175 HEIGHT=274' /* Window left, top, width, & height.  */
btncolr = '17, 71'                              /* Button color - <normal>, <selected> */


OPTIONS RESULTS

who = ADDRESS()
outfile = 'T:dirs.' || who

'GetHistory VAR=hist HISTORY=PATH'

IF hist.count > 0 THEN DO
  IF OPEN('out', outfile, 'W') THEN DO
    'OpenWindow' windims 'CMD'
    'Status W'
    w = result

    DO i=0 TO hist.count - 1
      name = hist.i
      IF LENGTH(name) > 30 THEN name = '...' || RIGHT(name, 26)  /* AddCmd names are limited to 30 chars */
      CALL WRITELN('out', 'AddCmd' name || ',' btncolr || ', NewDir' hist.i || '; CloseWindow' w)
    END

    CALL CLOSE('out')

    'BATCH' outfile
  END
END

