/* $VER:  DMPathHistAll.rexx 1.3 (19.2.03)

  DiskMaster II Path History All  v1.3
  02/19/03  J. Tierney

  Purpose:  Opens a Cmd window with button-links to the last visited
            directories.

  Usage:  Rexx DMPathHistAll.rexx

  Notes:
  - Edit the variables "windims" and "btncolr" (below) to suit yourself.
  - Each time this script is called it checks DM's path history and adds
    any new dirs in it to a file.
*/

windims = 'LEFT=251 TOP=7 WIDTH=175 HEIGHT=274' /* Window left, top, width, & height.  */
btncolr = '17, 71'                              /* Button color - <normal>, <selected> */


OPTIONS RESULTS

who = ADDRESS()
cmdfile = 'T:dirs.' || who
histfile = 'T:VisitedDirs.' || who

'GetHistory VAR=hist HISTORY=PATH'

IF hist.count > 0 THEN DO
  /* --- Write/append path history to a file. --- */
  opt = 'W'
  IF EXISTS(histfile) THEN opt = 'A'
  IF OPEN('out', histfile, opt) THEN DO
    DO i=0 TO hist.count - 1
      CALL WRITELN('out', hist.i)
    END
    CALL CLOSE('out')
    ADDRESS COMMAND 'Sort' histfile 'TO' histfile

    /* --- Read the file of visited dirs, skipping any duplicates. --- */
    IF OPEN('in', histfile, 'R') THEN DO
      i = 0
      last = ''
      DO UNTIL EOF('in')
        line = READLN('in')
        IF (LENGTH(line) > 0) & (COMPARE(line, last) ~= 0) THEN DO
          dirs.i = line
          i = i + 1
          last = line
        END
      END
      dirs.count = i
      CALL CLOSE('in')
    END

    /* Write 2 files:
        - Visited dirs (now without duplicate entries).
        - DM script that opens a command window listing the dirs.
    */
    IF OPEN('dout', histfile, 'W') THEN DO
      IF OPEN('cout', cmdfile, 'W') THEN DO
        'OpenWindow' windims 'CMD'
        'Status W'
        w = result

        DO i=0 TO dirs.count - 1
          CALL WRITELN('dout', dirs.i)
          name = dirs.i
          IF LENGTH(name) > 30 THEN name = '...' || RIGHT(name, 26)  /* AddCmd names are limited to 30 chars */
          CALL WRITELN('cout', 'AddCmd' name || ',' || btncolr || ', NewDir' dirs.i || '; CloseWindow' w)
        END
      END
      CALL CLOSE('cout')
      CALL CLOSE('dout')
      'BATCH' cmdfile  /* Execute the DM script. */
    END
  END
END

