/* $VER: Root All 1.0 (7.5.98) by J. Tierney

  Compares the paths of all open windows to a certain device/volume name.
  If there's a match, then go to the root dir (if we're not already there).

  Change the variables "dev" and "vol", below, to whatever you like.
*/

OPTIONS RESULTS

dev = 'RAM:'       /* Device name to root. */
vol = 'Ram Disk:'  /* Volume name to root. */

/* Change 'em to uppercase (the comparison is case-sensitive). */
dev = UPPER(dev)
vol = UPPER(vol)

dlen = LENGTH(dev)
vlen = LENGTH(vol)

/* Save the current source & dest windows. */
'STATUS P'
src = result
'STATUS D'
dest = result

/*
  Get the ID of the source window.
  We'll loop through all the windows until this ID comes up again.
*/
'WINDOW' src
'STATUS W'
sid = result

id = 9999
DO UNTIL id = sid
  'STATUS P'
  path = UPPER(result)
  plen = LENGTH(path)

  /*
    If the beginning of <path> = <dev> or <vol>, and if <path> is longer,
    then go to the root.
  */
  IF (plen ~= dlen) & (LEFT(path, dlen) = dev) THEN 'ROOT'
  IF (plen ~= vlen) & (LEFT(path, vlen) = vol) THEN 'ROOT'

  'WINDOW NEXT'
  'STATUS W'
  id = result
END

/* Restore the source & dest windows (Aren't we polite? :-) ). */
'WINDOW' dest
'WINDOW' src
